default:
    image: mcr.microsoft.com/dotnet/core/sdk:3.1

variables:
    PUBLISH_OUTPUT_DIR: publish
    ENTRYPOINT_DLL: AEWeb.dll
    DOCKER_IMAGE_VERSION: latest
  
stages:
    - build
    - release
    - image
  
build:
    stage: build
    script:
        - echo " RESTORING NUGET PACKAGES "
        - apt-get update && apt-get install -y nuget
        - dotnet restore --no-cache --force 
        - dotnet build -c Release --no-restore 
    artifacts:
        paths:
            - test
        expire_in: 1 hour
  
publish:
    stage: release
    script:
        - dotnet publish -c Release /p:EnvironmentName=Production -o $PUBLISH_OUTPUT_DIR 
    artifacts:
        paths:
            - publish/
        expire_in: 1 hour

containerize:
    stage: image
    image:
        name: gcr.io/kaniko-project/executor:debug
        entrypoint: [""]
    script:
        - echo "Generating $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG"
        - echo "FROM mcr.microsoft.com/dotnet/core/aspnet:3.1" > $CI_PROJECT_DIR/Dockerfile
        - echo "COPY $PUBLISH_OUTPUT_DIR ." >> $CI_PROJECT_DIR/Dockerfile
        - echo "EXPOSE 80" >> $CI_PROJECT_DIR/Dockerfile
        - echo "ENTRYPOINT [\"dotnet\", \"$ENTRYPOINT_DLL\"]" >> $CI_PROJECT_DIR/Dockerfile
        - cat $CI_PROJECT_DIR/Dockerfile
        - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
        - cat /kaniko/.docker/config.json
        - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:$DOCKER_IMAGE_VERSION
  
  